/*-
 * ===============LICENSE_START=======================================================
 * Acumos
 * ===================================================================================
 * Copyright (C) 2017 AT&T Intellectual Property & Tech Mahindra. All rights reserved.
 * ===================================================================================
 * This Acumos software file is distributed by AT&T and Tech Mahindra
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * This file is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ===============LICENSE_END=========================================================
 */

package com.wyy.service.tosca.vo.tgif;

import java.io.Serializable;

/**
 *
 *
 *
 */
public class Self implements Serializable {
    private static final long serialVersionUID = 5973109889778398211L;

    private String version;
    private String name;
    private String description;
    private String component_type;

    public Self() {

    }

    /**
     *
     * @param version
     *            Version
     * @param name
     *            Name
     * @param description
     *            Description
     * @param component_type
     *            Component type
     */
    public Self(String version, String name, String description, String component_type) {
        super();
        this.version = version;
        this.name = name;
        this.description = description;
        this.component_type = component_type;
    }

    /**
     * @return the version
     */
    public String getVersion() {
        return version;
    }

    /**
     * @param version
     *            the version to set
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     *            the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the description
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description
     *            the description to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * @return the component_type
     */
    public String getComponent_type() {
        return component_type;
    }

    /**
     * @param component_type
     *            the component_type to set
     */
    public void setComponent_type(String component_type) {
        this.component_type = component_type;
    }

}

